<?php
ob_start();
include(dirname(__FILE__).'/../../config/config.inc.php');
include(dirname(__FILE__).'/../../init.php');
include(dirname(__FILE__).'/cardcom.php');


$cardcom  = new Cardcom();

$cart = new Cart(intval($cookie->id_cart));

$customer = new Customer((int)($cart->id_customer));

$address = new Address(intval($cart->id_address_invoice));
$country = new Country(intval($address->id_country));
$state = NULL;
if ($address->id_state)
	$state = new State(intval($address->id_state));
$customer = new Customer(intval($cart->id_customer));
$myOrderTotal = number_format($cart->getOrderTotal(true, 3), 2, '.', '') ;
$params["TerminalNumber"] = Configuration::get("CARDCOM_TERMINAL_NUM");
$params["UserName"] = Configuration::get("CARDCOM_USERNAME");
$params["CodePage"] = "65001";
$params["SumToBill"] = $myOrderTotal;
$params["Operation"] = Configuration::get("CARDCOM_OPERATION");
$params["Language"] = Configuration::get("CARDCOM_LANG");
$params["CoinID"] = Configuration::get("CARDCOM_CURRENCY");

$ht = "http://";
if ((!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off')
    || $_SERVER['SERVER_PORT'] == 443)
	{
	$ht = "https://";
	}

$params["ErrorRedirectUrl"]   = $ht.$_SERVER['HTTP_HOST'] .__PS_BASE_URI__."modules/cardcom/pop.php?url=".urlencode($ht.$_SERVER['HTTP_HOST'] .__PS_BASE_URI__.'index.php?controller=cardcomm&failed=true');
$params["IndicatorUrl"] = $ht.$_SERVER['HTTP_HOST'] .__PS_BASE_URI__."modules/cardcom/validation.php?id_cart=".(int)$cart->id;
$params["SuccessRedirectUrl"] = $ht.$_SERVER['HTTP_HOST'] .__PS_BASE_URI__."modules/cardcom/pop.php?url=".urlencode($ht.$_SERVER['HTTP_HOST'] .__PS_BASE_URI__.'index.php?controller=order-confirmation&id_cart='.(int)$cart->id.'&id_module='.(int)$cardcom->id.'&key='.$customer->secure_key); // &slowvalidation


$params["APILevel"] = "10";
$params["CancelType"] = "0";
// $params["CancelUrl"] = "http://".$_SERVER['HTTP_HOST'] .__PS_BASE_URI__;
$params["ProductName"] = "Order Id: ".$cart->id;
$params["ReturnValue"] = $cart->id;

if(Configuration::get("CARDCOM_OPERATION") == 4)
{
    if (Configuration::get("CARDCOM_TERMINAL_NUM")=='1000')
    {
        $params["SuspendedDealJValidateType"] = "2";
    }
    else
    {
        $params["SuspendedDealJValidateType"] = "5";    
    }
    
    $params["SuspendedDealGroup"] = "1";
}

if(Configuration::get("CARDCOM_MAX") >= 1)
{
    $params["MaxNumberOfPayment"] = Configuration::get("CARDCOM_MAX");
}

$timestamp = strftime("%Y%m%d%H%M%S");

$currency_order = new Currency(intval($cart->id_currency));
$currency_module = $cardcom->getCurrency();

if (!Validate::isLoadedObject($address) OR !Validate::isLoadedObject($customer) OR !Validate::isLoadedObject($currency_module))
	die($realex->getL('CardCom error: (invalid address or customer)'));




if(Configuration::get("CARDCOM_INVOICE") == 1)
{
    $params['IsCreateInvoice']	= "true";
    $params['InvoiceHead.CustName']	= $customer->firstname." ".$customer->lastname;
    $params['InvoiceHead.CustAddresLine1']	=$address->address1;
    $params['InvoiceHead.CustCity']	= $address->city;
    $params['InvoiceHead.CustAddresLine2']	= $address->address2;
    $params['InvoiceHead.CustLinePH']=$address->phone;
    $params['InvoiceHead.Language']	= Configuration::get("CARDCOM_LANG");
    $params['InvoiceHead.Email'] = $customer->email;
    $params['InvoiceHead.SendByEmail']= 'true';
    $params['InvoiceHead.CoinID']= Configuration::get("CARDCOM_CURRENCY");
    $params['InvoiceHead.ExtIsVatFree'] = 'false';
    $params['InvoiceHead.Comments'] = "Order id: ".$cart->id;
    $ItemsCount = 1;
    $lang = strtolower(Configuration::get("CARDCOM_LANG"));
    $MyTempTotal = $myOrderTotal;

    foreach($cart->getProducts() as $key => $value)
    {
        //$UnitPrice = number_format($value['price'], 2, '.', '') ;
        $UnitPrice = number_format(Product::getPriceStatic($value['id_product']), 2, '.', '') ;
        $MyTempTotal -= $UnitPrice* (int)$value['cart_quantity'];

       // $params["InvoiceLines".$ItemsCount.".Description"] =   $value["name"];
        $params["InvoiceLines".$ItemsCount.".Description"] =  substr(strip_tags( preg_replace("/&#\d*;/", " ", $value["name"]) ), 0, 150);
        $params["InvoiceLines".$ItemsCount.".Price"]= $UnitPrice;
        $params["InvoiceLines".$ItemsCount.".Quantity"] = (int)$value['cart_quantity'];
        $params["InvoiceLines".$ItemsCount.".IsPriceIncludeVAT"] = "true";
        //$params["InvoiceLines".$ItemsCount.".ProductID"] = $value["id_product"];
        $params["InvoiceLines".$ItemsCount.".ProductID"] = $value["reference"];


        $ItemsCount++;
    }

    $Summery = $cart->getSummaryDetails();

    if ($Summery['total_shipping']!=0){
        $TotalShipping = number_format($Summery['total_shipping'], 2, '.', '') ;
        $MyTempTotal-= $TotalShipping;

        $params["InvoiceLines".$ItemsCount.".Description"] = substr(strip_tags( preg_replace("/&#\d*;/", " ", $Summery['carrier']->name) ), 0, 150);
        $params["InvoiceLines".$ItemsCount.".Price"]=$TotalShipping;
        $params["InvoiceLines".$ItemsCount.".Quantity"] = 1;
        $params["InvoiceLines".$ItemsCount.".IsPriceIncludeVAT"] = "true";
        $params["InvoiceLines".$ItemsCount.".ProductID"] = "Shipping";
        $ItemsCount++;
    }
/*
    if ($Summery['total_discounts']!=0){
        $total_discounts = number_format($Summery['total_discounts'], 2, '.', '') ;
        $MyTempTotal+= $total_discounts;
        if ($lang=='he'){
            $params["InvoiceLines".$ItemsCount.".Description"] = "הנחה";
        }else
        {
            $params["InvoiceLines".$ItemsCount.".Description"] = "Discount" ;           
        }

        $params["InvoiceLines".$ItemsCount.".Price"]= number_format(-1*$Summery['total_discounts'], 2, '.', '') ;
        $params["InvoiceLines".$ItemsCount.".Quantity"] = 1;
        $params["InvoiceLines".$ItemsCount.".IsPriceIncludeVAT"] = "true";
        $params["InvoiceLines".$ItemsCount.".ProductID"] = "Discounts";
        $ItemsCount++;
    } */
    $MyTempTotal = number_format($MyTempTotal, 2, '.', '') ; 
    if ($MyTempTotal!=0){
        if ($lang=='he'){
            $params["InvoiceLines".$ItemsCount.".Description"] = "שורת איזון";
        }else
        {
            $params["InvoiceLines".$ItemsCount.".Description"] = "Balance"   ;           
        }

        $params["InvoiceLines".$ItemsCount.".Price"]=$MyTempTotal;
        $params["InvoiceLines".$ItemsCount.".Quantity"] = 1;
        $params["InvoiceLines".$ItemsCount.".IsPriceIncludeVAT"] = "true";
        $params["InvoiceLines".$ItemsCount.".ProductID"] = "Discounts2";
        $ItemsCount++;
    }
    
    /*
    if($lang == "he")
	$TotalLineRow = $AddToString;
    else
        $params["InvoiceLines".$AddToString.".Description"] = "Total";
        
    $params["InvoiceLines".$AddToString.".Price"] = number_format($cart->getOrderTotal(true, 3), 2, '.', '') ;
    $params["InvoiceLines".$AddToString.".Quantity"] = "1";
    $params["InvoiceLines".$AddToString.".IsPriceIncludeVAT"] = "true"; 
    $params["InvoiceLines".$AddToString.".ProductID"] = "";
    $ItemsCount++;
    $AddToString = $ItemsCount;
    */
}

 

$urlencoded = http_build_query($params);

$curl = curl_init();
   
curl_setopt($curl, CURLOPT_URL, 'https://secure.cardcom.co.il/BillGoldLowProfile.aspx');
curl_setopt($curl, CURLOPT_POST, 1);
curl_setopt($curl, CURLOPT_FAILONERROR, true);
curl_setopt($curl, CURLOPT_POSTFIELDS, $urlencoded );
curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
curl_setopt($curl, CURLOPT_FAILONERROR,true);
$result = curl_exec($curl);


$exp = explode(';',$result);

$data = array();

if($exp[0] == "0")
{
    $profile =$exp[1];
}else
{
    $error_message = $exp[2];
}
$terminalnumber = Configuration::get("CARDCOM_TERMINAL_NUM");

$cardcom_url = $ht.$_SERVER['HTTP_HOST'] .__PS_BASE_URI__."cardcomm.php";




//die('index.php?controller=cardcomm&lowprofilecode='.$profile.'&terminalnumber='.$terminalnumber);

Tools::redirect('index.php?controller=cardcomm&lowprofilecode='.$profile.'&terminalnumber='.$terminalnumber);
ob_end_flush();
/*
$smarty->assign(array(
'redirect_text' => "",
'cardcom_url' =>$cardcom_url,
'error_message' => $error_message,
'profile' => $profile,
'terminalnumber' => $terminalnumber,
'lowprofilecode' =>$profile
));
$smarty->display(_PS_MODULE_DIR_.$cardcom->name.'/uk_redirect.tpl');

*/
?>